Skip to main content
All docs
V24.1

Localize Dashboard Component for React

  • 3 minutes to read

You can localize your applications - update their UI to match certain culture and language settings:

  • Translate UI element captions to a different language: dialog boxes, buttons, menu items, error messages, and so on (localization).
  • Format numbers, dates, and currencies according to specific culture settings (globalization).

web-dashboard-localization

Localize UI

To localize the user interface, add the component-specific JSON files that correspond to other cultures. For this, obtain a JSON object with the localization strings from DevExpress Localization Service. Modules to translate:

  • Dashboard.Core
  • Dashboard.Web
  • DataAccess
  • Web.Resources

Unpack a self-extracting archive and extract JSON resources. Add the dx-analytics-core.{lang}.json and dx-dashboards.{lang}.json files to your project. To translate the Text Editor‘s UI, you also need the dx-rich.{lang}.json file.

Pass the JSON object to the ResourceManager.setLocalizationMessages static method. Make sure that you apply localization before the Dashboard component is initialized and loaded.

Note

Since the Web Dashboard exports data on the server side, add satellite resource assemblies to your project to complete the localization process.

Refer to the following page to find all localizable strings: DashboardStringId

Localize Dates, Numbers, and Currencies

The Dashboard component for React supports both Intl and Globalize to format dates, numbers, and currencies.

Intl

The Web Dashboard uses Intl as a default way to apply culture-specific formatting. Intl is the short name used to refer to a particular ECMAScript Internationalization API object. The Web Dashboard supports this API out of the box. All you need to do is set the locale.

Globalize

Follow the instruction to import Globalize scripts: Use Globalize to Format Dates, Numbers, and Currencies.

Example

Follow the steps below to localize the Web Dashboard UI for the Spanish market (the es culture):

  1. Unpack a self-extracting archive and extract json resources. Copy the dx-analytics-core.es.json and dx-dashboards.es.json files with the required locale to the application’s directory (for example, to the localization folder).

  2. Import locale from the devextreme package (the localization module) and use the ResourceManager.setLocalizationMessages static method to load the localization strings. Call this method before the dashboard component is created.

  3. Call the locale method and pass the locale as a parameter to apply culture settings.

The following code shows how to:

  • import translated strings from JSON files;
  • set the es locale;
  • localize the specified string at runtime (the Export To button’s caption in the dashboard title).

For a React application, the most effective place to load translated strings is the main App function:

import React from 'react';
import './App.css';
import DashboardControl from 'devexpress-dashboard-react';
import { ResourceManager } from 'devexpress-dashboard';
import { locale } from "devextreme/localization";

function App() {    
  // Localize the Web Dashboard UI for the Spanish market (the 'es' culture):
  var culture = "es";
  ResourceManager.setLocalizationMessages(require(`../json resources/dx-dashboard.${culture}.json`));
  ResourceManager.setLocalizationMessages(require(`../json resources/dx-analytics-core.${culture}.json`));

  // Apply culture-specific formatting:
  locale(culture);  

  // Localize the specified string at runtime (the "Export To" button's caption in the dashboard title):
  ResourceManager.setLocalizationMessages({ "DashboardStringId.ActionExportTo": "Custom Text for Export Button" });  
  return (
    <div style={{ position : 'absolute', top : '0px', left: '0px', right : '0px', bottom: '0px' }}>
      <DashboardControl style={{ height: '100%' }} 
        endpoint="https://demos.devexpress.com/services/dashboard/api">
      </DashboardControl>
  </div>
  );
}

export default App;

View Example: Dashboard for React - Localization

Skip to main content
All docs
V23.2

Add a Web Dashboard to a Vue Application

  • 3 minutes to read

This article assumes that you implement a client-server architecture. An ASP.NET Core or an ASP.NET MVC application serves as the backend (server side). The client (frontend) application includes all the necessary styles, scripts and HTML-templates. Note that client scripts, libraries on the server side, and devexpress npm packages should have matching version numbers.

This topic describes how to import the DxDashboardControl component into a Vue application and display Web Dashboard.

View Example

Prerequisites

  • Make sure you have Node.js 6+ and npm 5.2+ installed on your machine.
  • In the command prompt, install the Vue CLI (command line interface tool) globally:

    npm install -g @vue/cli
    

    If you are not familiar with the basic concepts and patterns of Vue, please review the fundamentals before you continue: vuejs.org

Create a Vue Application

In the command prompt, create a Vue application with a default preset:

vue create dashboard-vue-app

Navigate to the created folder after the project is created:

cd dashboard-vue-app

Install the Dashboard Package

Install the following npm packages:

npm install devexpress-dashboard@23.2.6 devexpress-dashboard-vue@23.2.6 @devexpress/analytics-core@23.2.6 devextreme@23.2.6 --save devextreme-vue@23.2.6 --save

The devexpress-dashboard npm package references devextreme and @devexpress/analytics-core as peer dependencies. The peer dependencies packages should be installed manually. This allows you to control a version of the peer dependencies packages and guarantees that the package is installed once.

You can find all the libraries in the node_modules folder after installation is completed.

Add a Dashboard Component

Open the App.vue file and add the <DxDashboardControl> template to render the dashboard component:

<template>
    <div style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; ">
        <DxDashboardControl 
            style="height:100%"
            endpoint="https://demos.devexpress.com/services/dashboard/api"

        />
    </div>
</template>

<script>
import { DxDashboardControl } from 'devexpress-dashboard-vue';

export default {
    components: {
        DxDashboardControl,
    }
}
</script>

The DashboardControlOptions.endpoint property specifies the URL used to send data requests to a server. The value should consist of a base URL where the Web Dashboard’s server side is hosted and a route prefix - a value that is set in the MVC / .NET Core MapDashboardRoute properties.

Import Global Styles

Add the following global styles to the main.js file:

import Vue from 'vue'
import App from './App.vue'
import "ace-builds/css/ace.css";
import "ace-builds/css/theme/dreamweaver.css";
import "ace-builds/css/theme/ambiance.css"; 
import "devextreme/dist/css/dx.light.css";
import "@devexpress/analytics-core/dist/css/dx-analytics.common.css";
import "@devexpress/analytics-core/dist/css/dx-analytics.light.css";
import "@devexpress/analytics-core/dist/css/dx-querybuilder.css";
import "devexpress-dashboard/dist/css/dx-dashboard.light.css";

Vue.config.productionTip = false

new Vue({
  render: h => h(App),
}).$mount('#app')

Run the Application

Run the application.

npm run serve

Open http://localhost:8080/ in your browser to see the result. The Web Dashboard displays the dashboard stored on the preconfigured server (https://demos.devexpress.com/services/dashboard/api). To configure your own server, follow the instructions below: